/*
 * error.c - SATURN assembler, error display utility
 * (c) 1995 Mario Mikocevic Mozgy (Mario.Mikocevic@fer.hr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_ERRNO_H
#  include <errno.h>
#endif

#ifdef HAVE_ERRNO_H
# ifndef SYS_ERRLIST_DECLARED
extern int errno, sys_nerr;
extern char *sys_errlist[];
# endif
#endif
extern char *progname;

void error( char *s1, char *s2 )
{
	if( progname != NULL )
		fprintf( stderr, "%s: ", progname );
	fprintf( stderr, s1, s2 );
#ifdef HAVE_ERRNO_H
# ifdef SYS_ERRLIST_DECLARED
	if( errno > 0 && sys_nerr > errno )
		fprintf( stderr, " (%s)", sys_errlist[errno] );
	fputc( '\n', stderr );
# endif
#endif
	exit( -1 );
}
