#ifndef	_OPC_H_
#define	_OPC_H_

/* Symbol flags */
#define	SYM_NONE	0x00
#define	SYM_EXTERNAL	0x01	/* Ext vs unknown? */
#define	SYM_RESOLVED	0x02	/* Has value */
#define	SYM_FILE	0x04	/* RDSYMB filename? */
#define	SYM_GLOBAL	0x08	/* Global vs local */
#define	SYM_RELATIVE	0x10	/* Relative vs absolute */
#define	SYM_DEFINED	0x20	/* Symbol was defined on this pass?? */
#define	CPU_SWITCH1	0x40	/* CPU class switch */
#define	CPU_SWITCH2	0x80	/* CPU class switch */
#define	CPU_MASK	(CPU_SWITCH1 | CPU_SWITCH2)

/* Listing flags */
#define	LIST_CODE	0x01	/* Code */
#define	LIST_MACROS	0x02	/* Macros */
#define	LIST_INCLUDES	0x04	/* Includes */
#define	LIST_PSEUDO	0x08	/* Pseudos */
#define	LIST_MASK	0x0F	/* Mask for listing flags */
#define	LIST_ON		0x10	/* Listing on in current mode? */
#define	LIST_COUNT_ON	0x20	/* listcount lines to list */
#define	LIST_DISABLELINE	0x40	/* Current line is not listed */
#define	LIST_MASK2	0xF0	/* Mask for upper listing flags */

/* Opcode flags */
#define	OP_SHORTA	0x01	/* Has shorter [A] mnemonic */
#define	OP_SHORTB	0x02	/* Has shorter [B] mnemonic */	
#define	OP_TEST		0x04	/* Test instruction */
#define	OP_BRANCH	0x08	/* Follows test instrution */
#define	OP_PSEUDO	0x10	/* Pseudo mnemonic? */
#define	OP_MACRO	0x20	/* User defined macro */
#define	CPU_SWITCH1	0x40	/* CPU switch */
#define	CPU_SWITCH2	0x80	/* CPU switch */
#define	OP_COMBOS	0x100	/* COMBOS supplement, ?maybe 0x100? */

/* Opcode operands */
#define	ARG_NONE	0x00	/* No field */
#define	ARG_FS		0x01	/* Field selector */
#define	ARG_FSN		0x02	/* Field selector or digit */
#define	ARG_FIXED_SIZE	0x02	/* Above are of fixed size */
#define	ARG_NIB		0x03	/* Nibble 0-15 */
#define	ARG_EXPR	0x04	/* Expression */
#define	ARG_LABEL	0x05	/* Label, expr allowed via option */
#define	ARG_EXPR2	0x06	/* Expression, same as 4 ?? */
#define	ARG_HEX		0x07	/* NIBHEX */
#define	ARG_DHEX	0x08	/* Dn=HEX */
#define	ARG_LHEX	0x09	/* LrHEX */
#define	ARG_LASC	0x0A	/* LrASC */
#define	ARG_ASC		0x0B	/* NIBASC or STRING */
#define	ARG_LINK	0x0C	/* INC(n) or LINK or SLINK */
#define	ARG_INVALID	0x0D	/* Invalid */
#define	ARG_FSEXP	0x0E	/* fs,expr */
#define	ARG_FSEXP1	0x0F	/* fs,expr, disallow single nibble fields */
#define	ARG_FS1		0x10	/* fs, disallow single nibble fields */
#define	ARG_LSTR	0x11	/* LCSTR LASTR */
#define	ARG_BIN		0x12	/* NIBBIN */
#define	ARG_LENASC	0x13	/* ASC(x) */
#define	ARG_LENHEX	0x14	/* HEX(x) */

/* Opcode classes */
#define	CLASS_NORMAL	0x00
#define	SUBCLASS_VL	0x01	/* GOVLNG GOSBVL */

#define	CLASS_LABEL	0x01	/* GO instructions */
#define	SUBCLASS_GOTO	0x00	/* GOTO GOLONG GOYES GOC GONC REL */
#define	SUBCLASS_GOSUB	0x01	/* GOSUB GOSUBL */
#define	SUBCLASS_REL	0x02	/* REL(n) */

#define	CLASS_LINK	0x02	/* LINK SLINK BSS */
#define	SUBCLASS_SLINK	0x00	/* SLINK BSS */
#define	SUBCLASS_LINK	0x01	/* LINK */

#define	CLASS_INC	0x03	/* INC(n) */
#define	CLASS_RDSYMB	0x04	/* RDSYMB */
#define	CLASS_END	0x05	/* END */
#define	CLASS_EQU	0x06	/* = */
#define	CLASS_IF	0x0A	/* IF */
#define	CLASS_IFEXPR	0x0B	/* IFNE IFGT etc */
#define	CLASS_IFSTR	0x0C	/* IFSTRLE IFSTRGE IFSTRNE etc */
#define	SUBCLASS_LESS	0x01	/* IFLT IFNEG */
#define	SUBCLASS_EQ	0x02	/* IFZER IFEQ */
#define	SUBCLASS_EQLESS	0x03	/* IFLE */
#define	SUBCLASS_GREAT	0x04	/* IFPOS IFGT */
#define	SUBCLASS_DIFF		0x05	/* IFNE IFNZ */
#define	SUBCLASS_EQGRE	0x06	/* IFGE */

#define	CLASS_IFDEF	0x0F	/* IFDEF */
#define	CLASS_IFNDEF	0x10	/* IFNDEF */
#define	CLASS_IFOPC	0x11	/* IFOPC */
#define	CLASS_IFNOPC	0x12	/* IFNOPC */
#define	CLASS_IFPASS1	0x13	/* IFPASS1 */
#define	CLASS_IFPASS2	0x14	/* IFPASS2 */
#define	CLASS_IFCRY1	0x15	/* IFCARRYSET */
#define	CLASS_IFCRY0	0x16	/* IFCARRYCLR */
#define	CLASS_IFCRYANY	0x17	/* IFANYCARRY */
#define	CLASS_IFREACHED	0x18	/* IFREACHED */
#define	CLASS_ELSE	0x26	/* ELSE */
#define	CLASS_ENDIF	0x27	/* ENDIF */
#define	CLASS_TITLE	0x28	/* TITLE */
#define	CLASS_STITLE	0x29	/* STITLE */
#define	CLASS_EJECT	0x2A	/* EJECT */
#define	CLASS_LIST	0x2B	/* LIST */
#define	CLASS_LISTM	0x2C	/* LISTM */
#define	CLASS_UNLIST	0x2D	/* UNLIST */
#define	CLASS_SETLIST	0x2E	/* SETLIST */
#define	CLASS_CLRLIST	0x2F	/* CLRLIST */
#define	CLASS_LISTALL	0x30	/* LISTALL */
#define	CLASS_MACRO	0x32	/* MACRO */
#define	CLASS_ENDM	0x33	/* ENDM */
#define	CLASS_EXITM	0x34	/* EXITM */
#define	CLASS_INCLUDE	0x35	/* INCLUDE */
#define	CLASS_CHARMAP	0x36	/* CHARMAP */
#define	CLASS_SETFLAG	0x3C	/* SETFLAG */
#define	CLASS_CLRFLAG	0x3D	/* CLRFLAG */
#define	CLASS_SETCARRY	0x3E	/* SETCARRY */
#define	CLASS_CLRCARRY	0x3F	/* CLRCARRY */
#define	CLASS_NOTREACH	0x40	/* NOTREACHED */
#define	CLASS_JUMP	0x41	/* GOSHORT JUMP */
#define	CLASS_MSG	0x46	/* MESSAGE */
#define	CLASS_ABASE	0x47	/* ABASE */
#define	CLASS_ALLOC	0x48	/* ALLOC */
#define	CLASS_UNDEF	0x49	/* UNDEFINE OPCODE */
#define	CLASS_FOR	0x50	/* FOR NEXT loop */
#define	CLASS_NEXT	0x51
#define	CLASS_EXITF	0x52
#define	CLASS_REPEAT
#define	CLASS_UNTIL
#define	CLASS_DO
#define	CLASS_WHILE

#define	IMP_NONE	0	/* Nothing coming up */
#define	IMP_INCLUDE	1
#define	IMP_MACRO	-1
#define	IMP_END	2
#define	IMP_EXITM	-2
#define	IMP_INSERT	3	/* Not sure about this.. */

#define	IMTYPE_CODE		0	/* Normal code */
#define	IMTYPE_INCLUDE	1	/* Include code */
#define	IMTYPE_MACRO		-1	/* Macro code */

struct macro {
	char	*m_line;
	struct macro	*m_next;
};

struct optable {
	char	op_mnem[13];
	char	op_operand;
	unsigned short	op_flags;
	short	op_length;
	char	op_string[10];
	char	alt1_op_string[10];
	char	alt2_op_string[10];
	char	op_fs_nib;
	char	op_offset;
	short	op_size;
	short	op_bias;
	unsigned char	op_class;
	unsigned char	op_subclass;
	unsigned char	op_Afield;
	unsigned char	op_Bfield;
	unsigned char	op_carrystate;
/*	char	op_spare[3]; removed to shorten mem usage */
	struct macro	*op_macroptr;
	struct optable	*op_left;
	struct optable	*op_right;
};

void	readoptable();
#endif
