#ifndef	_OPCODE_H_
#define	_OPCODE_H_

struct loop {
	char	*lp_filename;
	long	lp_fpos;
	char	lp_label[SYM_NAME_LEN + 1];
	long	lp_value;
	long	lp_end;
	long	lp_step;
};

struct lineref {
	unsigned long   l_line;
	struct lineref  *l_next;
};

struct expression {
	int     e_extcount;
	int     e_relcount;
	char    e_name[SYM_NAME_LEN + 2]; /* ':' or '=' included */
	long    e_value;
};

struct o_symbol {
	char    os_name[SYM_NAME_LEN];
	char    os_fillcount[2];
	char    os_value[4];
};

struct SATURN {
	char    id[6];
	char    length[2];
	char    nibbles[4];
	char    symbols[2];
	char    references[2];
	char    start[4];
	char    absolute[1];
	char    filler[1];
	char    date[26];
	char    title[40];
	char    softkeys[20];
	char    version[26];
	char    romid[4];
	char    reserved[118]; /* 256 - all above */
};

struct OPCODE {
	char    value[MAXOPLINE + 1];
	unsigned long   length;
} opcode;

struct symbol {
	char    s_name[SYM_NAME_LEN + 1];
	long    s_value;
	char    s_red;
	unsigned char   s_flags;
	struct lineref  *s_lineref;
	unsigned int    s_fillcount;
	struct fillref  *s_fillref;
	struct symbol   *s_left;
	struct symbol   *s_right;
};

struct fillref {
	long    f_address;
	long    f_bias;
	unsigned char   f_class;
	unsigned char   f_subclass;
	int     f_length;
	struct fillref  *f_next;
};

struct fs {
	char    string[3];
	int     value;
};

void    zerrmsg(char *);
char    *uppercase(char *);
struct optable  *getopmem(int);
struct optable  *add_optable(struct optable *, struct optable **);
int     pushcond(void);
int     checkcond(void);
void    readoptable(void);
void    alloptable(void (*)(), struct optable *);
struct optable  *findoptable(char *, struct optable *);
struct optable  *all_findoptable(char *);
int     fromhex(char);
char    *getterm(void);
int     getfs(void);
struct expression       *getdigitexpr(void);
int     getasc(char *, int);
int     gethex(char *, int);
unsigned long   getlength(void);
struct o_symbol *getobject(int);
struct OPCODE *getopcode(char *);
void    setnibble(char *, int);
void    setnibbles(char *, int, int);
void    setexpr(long);
void    setfield(int);
unsigned long   opcodelen(char *);
void    rdsymb(void);
void    char_map(void);
void    reverse(char *);
void    breverse(char *);
struct optable  *newmacro(char *);
void    putmacroline(void);
int     decode(char **);
void    dofree(struct optable *);
struct expression       *doexpr_fill(void);
void    cleanmacros(void);

extern	void
	error( char *, ... ),
	DEBUG_PRN( char *, ... ),
	errmsg( char * ),
	skipwhite( void ),
	addfillref( struct expression * ),
	addlineref( struct symbol * ),
	xaddlabel( char *, long, int, int ),
	addlabel( char *, long, int );
extern	int
	isfield( void ),
	getfield( char *, int, char * ),
	absexpr( struct expression * ),
	getsymbol( void );
extern	unsigned int	get_u16( unsigned char * );
extern	long	get_32( unsigned char * );
extern	unsigned long	get_u32( unsigned char * );
extern	FILE	*openfile( char *, char *, char *, char *, char ** );
extern	struct expression
	*doexpr( void ),
	*popexpr( void );
extern	struct symbol
	*addsymbol( char *, long, int ),
	*findsymbol( char * );

#endif
