#ifndef _SLOAD_H_
#define _SLOAD_H_

/* SLOAD Two Letter Command Identifiers */

#define	CMD_ABORT	0x4142	/*	 "AB"	*/
#define	CMD_ANNOTATE	0x414E	/*	 "AN"	*/
#define	CMD_BOUNDARY	0x424F	/*	 "BO"	*/
#define	CMD_CHECK	0x4348	/*	 "CH"	*/
#define	CMD_CKSUM	0x434B	/*	 "CK"	*/
#define	CMD_CRC		0x4352	/*	 "CR"	*/
#define	CMD_DBUG	0x4442	/*	 "DB"	*/
#define	CMD_DEFINE	0x4445	/*	 "DE"	*/
#define	CMD_END		0x454E 	/*	 "EN"	*/ 
#define	CMD_ECRC	0x4543 	/*	 "EC"	*/ 
#define	CMD_ERROR	0x4552 	/*	 "ER"	*/ 
#define	CMD_FLAG	0x464C	/*	 "FL"	*/
#define	CMD_FORCE	0x464F	/*	 "FO"	*/
#define	CMD_HELP	0x4845	/*	 "HE"	*/
#define	CMD_ID		0x4944	/*	 "ID"	*/
#define	CMD_IF		0x4946	/*	 "IF"	*/
#define	CMD_IF_NOT	0x4E4F	/*	 "NO"	*/
#define	CMD_KCRC	0x4B43	/*	 "KC"	*/
#define	CMD_LIST	0x4C49	/*	 "LI"	*/
#define	CMD_LLU		0x4C4C	/*	 "LL"	*/
#define	CMD_LOCATE	0x4C4F	/*	 "LO"	*/
#define	CMD_NEXT	0x4E45	/*	 "NE"	*/
#define	CMD_OPTION	0x4F50	/*	 "OP"	*/
#define	CMD_OUTPUT	0x4F55	/*	 "OU"	*/
#define	CMD_PATCH	0x5041	/*	 "PA"	*/
#define	CMD_PURGE	0x5055	/*	 "PU"	*/
#define	CMD_RANGE	0x5241	/*	 "RA"	*/
#define	CMD_RELOCATE	0x5245	/*	 "RE"	*/
#define	CMD_SEARCH	0x5345	/*	 "SE"	*/
#define	CMD_SOFTKEYS	0x534F	/*	 "SO"	*/
#define	CMD_START	0x5354	/*	 "ST"	*/
#define	CMD_SUPPRESS	0x5355	/*	 "SU"	*/
#define	CMD_TITLE	0x5449	/*	 "TI"	*/
#define	CMD_TRANSFER	0x5452	/*	 "TR"	*/
#define	CMD_TSTAMP	0x5453	/*	 "TS"	*/
#define	CMD_UDEFINE	0x5544	/*	 "UD"	*/
#define	CMD_UFLAG	0x5546	/*	 "UF"	*/
#define	CMD_UNRESOLVED	0x554E	/*	 "UN"	*/
#define	CMD_URELOCATE	0x5552	/*	 "UR"	*/
#define	CMD_USEARCH	0x5553	/*	 "US"	*/
#define	CMD_ZERO	0x5A45	/*	 "ZE"	*/
#define	CMD_COMMENT	0x2A2A	/*	 "**"	*/

/* Modifiers for END command */

#define	CMD_END_NORESOLVE	0x4E4F	/*	"NO"	*/
#define	CMD_END_RESOLVE		0x5245	/*	"RE"	*/

/* Modifiers for LIST command */

#define	CMD_LIST_ALL		0x414C	/*	"AL"	*/
#define	CMD_LIST_CODE		0x434F	/*	"CO"	*/
#define	CMD_LIST_ENTRIES	0x454E	/*	"EN"	*/
#define	CMD_LIST_LXREF		0x4C58	/*	"LX"	*/
#define	CMD_LIST_REFERENCES	0x5245	/*	"RE"	*/
#define	CMD_LIST_SHORTNREF	0x5348	/*	"SH"	*/
#define	CMD_LIST_SUMMARY	0x5355	/*	"SU"	*/
#define	CMD_LIST_SYMBOLS	0x5359	/*	"SY"	*/
#define	CMD_LIST_UNRESOLVED	0x554E	/*	"UN"	*/
#define	CMD_LIST_XREF		0x5852	/*	"XR"	*/

#define	LIST_XREF		0x80
#define	LIST_UNRESOLVED		0x40
#define	LIST_CODE		0x20
#define	LIST_SUMMARY		0x10
#define	LIST_SHORTNREF		0x08
#define	LIST_REFERENCES		0x04
#define	LIST_LXREF		0x02
#define	LIST_SYMBOLS		0x01
#define	LIST_ALL		0xFF
#define	LIST_NONE		0x00
#define	LIST_DEFAULT		( ( LIST_XREF ) | ( LIST_UNRESOLVED ) | ( LIST_SUMMARY ) )

/* Modifiers for OPTION command */

#define	CMD_OPT_CODE		0x434F	/*	"CO"	*/
#define	CMD_OPT_SYMBOLS		0x5359	/*	"SY"	*/
#define	CMD_OPT_RELOCATABLE	0x5245	/*	"RE"	*/
#define	CMD_OPT_NREFS		0x4E52	/*	"NR"	*/

/* Function prototypes */

extern	void
	error( char *, ... ),
	DEBUG_PRN( char *, ... ),
	setname( char **, char * );
extern	FILE	*openfile( char *, char *, char *, char *, char ** );

extern	void	s_8A85_000A( void );
extern	void	s_8A85_0080( void (*)( ) );
extern	struct	symbol	*s_8A85_0414( char * );
extern	struct	symbol	*s_8A85_0462( char * );
extern	void	s_8A85_04DE( char * );
extern	void	addfillref( struct symbol *, union SFC * );


extern	void	set_8( unsigned char *, unsigned char );
extern	void	set_16( unsigned char *, unsigned int );
extern	void	set_32( unsigned char *, unsigned long );
extern	int	get_16( unsigned char * );
extern	long	get_32( unsigned char * );
extern	unsigned	int	get_u16( unsigned char * );
extern	unsigned	long	get_u32( unsigned char * );

extern	char	get_chr( void );
extern	void	backchar( void );
extern	int	getfield( char *, int , char * );
extern	void	skipwhite( void );
extern	void	next_token( void );
extern	char	*getline( char *, FILE * );
extern	long	getaddress( void );
extern	int	getcommand( void );
extern	char	*gettoken( void );
extern	char	*getsymbol( char * );
extern	char	*getstring( void );
extern	void	remove_tabs( char *, char *, int );

extern	void	do_all_symbols( void (*)( ) );

unsigned char	*getblock( void );
extern	int	getnibble( long );
extern	void	fillbyte( long, long );
extern	void	fillnibble( long, long );
extern	void	read_code( long, long );
extern	long	compute_crc( long, long, long, long );
extern	long	compute_kcrc( long, long, long, long );
extern	long	compute_ecrc( long, long );
extern	int	compute_cksum( long, long );

extern	void	write_objfile( void );

extern	int	getopt( int , char * const [], const char * );

void	parse_line( int );

#endif

