#ifndef	_STRUCT_H_
#define	_STRUCT_H_

/* structures */

struct SATURN {
	char	id[6];
	char	length[2];
	char	nibbles[4];
	char	symbols[2];
	char	references[2];
	char	start[4];
	char	absolute[1];
	char	filler[1];
	char	date[26];
	char	title[40];
	char	softkeys[20];
	char	version[26];
	char	romid[4];
	char	reserved[118]; /* 256 - all above */
};

struct o_symbol {
	char	os_name[SYM_NAME_LEN];
	char	os_fillcount[2];
	char	os_value[4];
};

struct o_fillref {
	char	of_class[1];
	char	of_subclass[1];
	char	of_address[4];
	char	of_bias[4];
	char	of_length[2];
	char	of_reserved[OF_RESERVED];
};

union SFC {
	struct	o_symbol	s;
	struct	o_fillref	f;
	char	c[SYM_NAME_LEN + 6];
};

struct module {
/* add m_ prefix !! */
	char	*filename;			/* d_00 */
	long	address;				/* d_04 */
	long	length;				/* d_08 */
	char	title[40];			/* d_12 */
	char	date[26];			/* d_52 */
	int	error;				/* d_78 */
	struct module	*next;	/* d_80 */
};

struct fillref {
	long	f_address;				/* d_00 */
	long	f_bias;					/* d_04 */
	unsigned char	f_class;		/* d_08 */
	unsigned char	f_subclass;	/* d_09 */
	int	f_length;				/* d_10 */
	struct module	*f_module;	/* d_12 */ /* not in org. SASM */
	struct fillref	*f_next;		/* d_16 */
};

struct symbol {
	struct symbol	*s_left;				/* d_00 */
	struct symbol	*s_right;			/* d_04 */
	struct module	*s_module;			/* d_08 */
	struct fillref	*s_fref_first;		/* d_12 */
	struct fillref	**s_fref_next;		/* d_16 */
	long	s_value;							/* d_20 */
	unsigned	int	s_flags;		/* word, d_24 */
	char	s_name[SYM_NAME_LEN + 1];	/* d_26 */
};

struct checksum {
	char	ch_name[SYM_NAME_LEN + 1];	/* d_00 */
	long	d_13;
	long	d_17;
	struct checksum	*ch_next;		/* d_21 */
};

struct crc {
	long	cr_start;			/* d_00 */
	long	cr_offset;			/* d_04 */
	long	cr_reads;			/* d_08 */
	long	cr_sectors;			/* d_12 */
	struct crc	*cr_next;	/* d_16 */
	int	cr_type;				/* d_20 */
};

#endif
