#include <stdio.h>
#include <stdlib.h>
#ifdef  SUNOS
#include <unistd.h>
#endif

#define DOLIB 0x2B40
#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

/*                   H P H P 4 8 - X dolib */
char    *firstones = "840584054383D28504B20";
char    *firstmask = "111111111111110011111";
int     firstlen = 16+5;

int     nibble1 = FALSE;
int     goteof = FALSE;
int     curbyte;
FILE    *infile;

int getnib(void)
{
	int nib;
	if(nibble1)
		nib = (curbyte>>4) & 0xF;
	else
	{
		curbyte = fgetc(infile);
		if(curbyte == EOF)
			goteof = TRUE;
		nib = curbyte & 0xF;
	}
	nibble1 = !nibble1;
	return(nib);
}

void lberror(void)
{
	fprintf(stderr, "Not a library object, ignoring CRC fill.\n");
	exit(0);
}

int main(int argc, char **argv)
{
	int     i, nib;
	int wrongheader = FALSE;
	unsigned long kcrc, liblen, libcrc;
	long    filepos;

	fprintf(stderr, "lbcrc v1.0 by Fin\n");
	if(argc != 2)
	{
		fprintf(stderr, "Usage: lbcrc <file>\n");
		exit(-1);
	}
	if((infile = fopen(argv[1], "r+b")) == NULL)
	{
		perror(argv[1]);
		exit(1);
	}
	
	i = 0;
	while((i<firstlen) && !wrongheader)
	{
		nib = getnib();
		if(goteof)
			lberror();
		if(nib >= 0 && nib <= 9)
			nib += '0';
		else
			nib += 'A' - 10;
		if(firstmask[i] != 0)
			if(firstones[i] != nib)
				wrongheader = TRUE;
		i++;
	}
	if(wrongheader)
		lberror();

	liblen = 0;
	kcrc = 0;
	for(i=0 ; i<5 ; i++)
	{
		nib = getnib();
		if(goteof)
			lberror();
		liblen += nib << (i*4);
		kcrc = (((kcrc ^ (unsigned long) (nib & 0xF)) & 0xF)
			* (unsigned long) 0x1081)
			^ (unsigned long) (kcrc >> 4);
	}
	if(liblen <= 9)
		lberror();
	i = liblen-9;
	while(i-- > 0)
	{
		nib = getnib();
		if(goteof)
			lberror();
		kcrc = (((kcrc ^ (unsigned long) (nib & 0xF)) & 0xF)
			* (unsigned long) 0x1081)
			^ (unsigned long) (kcrc >> 4);
	}
	kcrc &= 0xffff;
	libcrc = 0;
	for(i=0 ; i<4 ; i++)
		libcrc += getnib() << (4*i);
	if(goteof)
		lberror();
	printf("\tLibrary CRC:\t%04X\n\tTrue CRC:\t%04X\n", libcrc, kcrc);

	/* Now fix the crc nibbles */
	if(nibble1)
	{
		/* xx xc cc cx  */
		/*            ^ */
		fseek(infile, -3L, SEEK_CUR);
		nib = fgetc(infile) & 0xf;
		fseek(infile, -1L, SEEK_CUR);
		fputc( nib + ((kcrc & 0xF)<<4), infile);
		fputc( (kcrc >> 4) & 0xFF, infile);
		fputc( (kcrc >> 12) & 0xF, infile);
	}
	else
	{
		/* xx xx cc cc  */
		/*            ^ */
		fseek(infile, -2L, SEEK_CUR);
		fputc(kcrc & 0xff, infile);
		fputc(((kcrc>>8)&0xff), infile);
	}
	return(0);
}
