/*
 * symb.c - SATURN loader, searching and parsing symbols
 * (c) 1995 Mario Mikocevic Mozgy (Mario.Mikocevic@fer.hr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef	HAVE_CONFIG_H
#  include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#ifdef	HAVE_STRING_H
#  include <string.h>
#else
#  include <strings.h>
#endif

#include "struct.h"

extern struct symbol *newsymbol( char * );

struct symbol	d_5d7c;

/* s_8D4E */

struct symbol	*s_8D4E_000C( char *bp6, struct symbol **bp10, int bp14 ) /* 000C */
{
	struct symbol	*bp_4, *bp_10, *bp_14, *bp_18;
	register	int si = TRUE;

/* AAAAAAAARRRRRRRRRRRRRRRGHHHHHHHH!
 * I hate optimising compilers :]
 * it took me whole two days to figure this out !
 */

	bp_18 = *bp10;
	bp_14 = bp_10 = &d_5d7c;
	d_5d7c.s_left = NULL;
	d_5d7c.s_right = NULL;
	if( bp_18 != NULL ) {
		si = *bp_18->s_name - *bp6;
		if( si == 0 )
			si = strcmp( bp_18->s_name, bp6 );
		if( si == 0 )
			return bp_18;
		while( si != 0 ) {
			if( si == 0 )
				break;
			if( si > 0 ) {
				bp_4 = bp_18->s_left;
				if( bp_4 == NULL ) {
					bp_14->s_left = bp_18;
					bp_10->s_right = NULL;
					break;
				}
				si = *bp_4->s_name - *bp6;
				if( si == 0 )
					si = strcmp( bp_4->s_name, bp6 );
				if( si > 0 ) {
					bp_18->s_left = bp_4->s_right;
					bp_14->s_left = bp_4;
					bp_4->s_right = bp_18;
					bp_14 = bp_4;
					bp_18 = bp_4->s_left;
					if( bp_18 == NULL ) {
						bp_10->s_right = NULL;
						break;
					}
					si = *bp_18->s_name - *bp6;
					if( si == 0 )
						si = strcmp( bp_18->s_name, bp6 );
					continue;
				}
				bp_14->s_left = bp_18;
				bp_14 = bp_18;
				bp_18 = bp_4;
			}
			if( si == 0 )
				break;
			bp_4 = bp_18->s_right;
			if( bp_4 == NULL ) {
				bp_10->s_right = bp_18;
				bp_14->s_left = NULL;
				break;
			}
			si = *bp_4->s_name - *bp6;
			if( si == 0 )
				si = strcmp( bp_4->s_name, bp6 );
			if( si < 0 ) {
				bp_18->s_right = bp_4->s_left;
				bp_10->s_right = bp_4;
				bp_4->s_left = bp_18;
				bp_10 = bp_4;
				bp_18 = bp_4->s_right;
				if( bp_18 == NULL ) {
					bp_14->s_left = NULL;
					break;
				}
				si = *bp_18->s_name - *bp6;
				if( si == 0 )
					si = strcmp( bp_18->s_name, bp6 );
				continue;
			}
			bp_10->s_right = bp_18;
			bp_10 = bp_18;
			bp_18 = bp_4;
		}
	}
	if( si == 0 ) {
		bp_10->s_right = bp_18->s_left;
		bp_14->s_left = bp_18->s_right;
		bp_18->s_left = d_5d7c.s_right;
		bp_18->s_right = d_5d7c.s_left;
		*bp10 = bp_18;
		return bp_18;
	}
	if( bp14 ) {
		bp_18 = newsymbol( bp6 );
		bp_18->s_left = d_5d7c.s_right;
		bp_18->s_right = d_5d7c.s_left;
		*bp10 = bp_18;
		return bp_18;
	}
	if( bp_14->s_left != NULL ) {
		bp_10->s_right = d_5d7c.s_left;
		if( d_5d7c.s_right == NULL )
			*bp10 = d_5d7c.s_left;
		else
			*bp10 = d_5d7c.s_right;
	} else {
		bp_14->s_left = d_5d7c.s_right;
		if( d_5d7c.s_left == NULL )
			*bp10 = d_5d7c.s_right;
		else
			*bp10 = d_5d7c.s_left;
	}
	return NULL;
}

void	s_8D4E_03EE( struct symbol *bp6, void *doit( struct symbol * ) ) /* 03EE */
{
	struct symbol	*bp_4, *bp_8, *bp_12, *bp_16, *bp_20, *bp_24;

	bp_20 = bp_16 = bp6;
	bp_4 = bp_8 = NULL;
	if( bp_16 != NULL )
		while( 1 ) {
			if( bp_16->s_left != NULL ) {
				bp_24 = bp_16->s_left;
				bp_16->s_left = bp_20;
				bp_20 = bp_16;
				bp_16 = bp_24;
				continue;
			}
			doit( bp_16 ); /* call dword ptr [bp+0Ah] */
			if( bp_16->s_right != NULL ) {
				bp_24 = bp_16->s_right;
				bp_16->s_right = bp_20;
				bp_20 = bp_16;
				bp_16 = bp_24;
				continue;
			}
			bp_12 = bp_16;
			while( 1 ) {
				if( bp_16 == bp6 )
					return;
				if( bp_20->s_right == NULL ) {
					doit( bp_20 ); /* call dword ptr [bp+0Ah] */
					bp_24 = bp_20->s_left;
					bp_20->s_left = bp_16;
					bp_16 = bp_20;
					bp_20 = bp_24;
					continue;
				}
				if( bp_20->s_left == NULL ) {
					bp_24 = bp_20->s_right;
					bp_20->s_right = bp_16;
					bp_16 = bp_20;
					bp_20 = bp_24;
					continue;
				}
				if( bp_20 != bp_4 )
					break;
				bp_24 = bp_8;
				bp_4 = bp_8->s_right;
				bp_8 = bp_8->s_left;
				bp_24->s_right = NULL;
				bp_24->s_left = NULL;
				bp_24 = bp_20->s_left;
				bp_20->s_left = bp_20->s_right;
				bp_20->s_right = bp_16;
				bp_16 = bp_20;
				bp_20 = bp_24;
			}
			doit( bp_20 );
			bp_12->s_left = bp_8;
			bp_12->s_right = bp_4;
			bp_8 = bp_12;
			bp_4 = bp_20;
			bp_24 = bp_20->s_right;
			bp_20->s_right = bp_16;
			bp_16 = bp_24;
		}
}
